#include "Type_Def.h"

#if !defined(__PCI_DIO_H__)
    #define __PCI_DIO_H__

#ifdef DLL_EXPORTS
#define DLL_API __declspec(dllexport)
#else
#define DLL_API __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
//Initial
short PASCAL _PCI_DIO_open_card(unsigned char* nDeviceCount);
void  PASCAL _PCI_DIO_close(void);
short PASCAL _PCI_DIO_get_card_no(unsigned char nDeviceNo, unsigned short* nCardNo);
short PASCAL _PCI_DIO_get_fpga_version(unsigned char nCardNo, unsigned short* nVersion);
short PASCAL _PCI_DIO_get_hardware_id(unsigned char nCardNo, unsigned short* nDeviceID);

//DIO
short PASCAL _PCI_DIO_set_single_output(unsigned char nCardNo, unsigned short nbit, unsigned short onoff);
short PASCAL _PCI_DIO_get_single_output(unsigned char nCardNo, unsigned short nbit, unsigned short* onoff);
short PASCAL _PCI_DIO_get_single_input(unsigned char nCardNo, unsigned short nbit, unsigned short* onoff);

short PASCAL _PCI_DIO_set_output(unsigned char nCardNo, unsigned short nport, unsigned char value);
short PASCAL _PCI_DIO_get_output(unsigned char nCardNo, unsigned short nport, unsigned char* value);
short PASCAL _PCI_DIO_get_input(unsigned char nCardNo, unsigned short nport, unsigned char* value);

short PASCAL _PCI_DIO_set_output_error_handle(unsigned char nCardNo, unsigned short onoff);
short PASCAL _PCI_DIO_get_output_error_handle(unsigned char nCardNo, unsigned short* onoff);

//PCI_DIO_Interrupt
short PASCAL _PCI_DIO_int_control(unsigned char nCardNo ,unsigned short enable);
short PASCAL _PCI_DIO_set_int_factor(unsigned char nCardNo,unsigned short int_factor);
short PASCAL _PCI_DIO_get_int_factor(unsigned char nCardNo,unsigned short* int_factor);
short PASCAL _PCI_DIO_link_interrupt(unsigned char nCardNo, void (__stdcall *callbackAddr)(unsigned char nCardNo));
short PASCAL _PCI_DIO_get_int_status(unsigned char nCardNo ,unsigned short *int_status);
short PASCAL _PCI_DIO_get_int_io_control(unsigned char nCardNo ,unsigned short *io_control);



#ifdef __cplusplus
}
#endif

#endif