﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using PCI_DIO;

namespace PCI_DIO
{
    public partial class Form1 : Form
    {
        short rc;
        byte  exis_DIOtcard = 0;
        byte gCardNo = 0;
        ushort[] gCardNoList = new ushort[16];

        public Form1()
        {
            InitializeComponent();          
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           
        }
        private void btninitial_Click(object sender, EventArgs e)
        {
            byte i;
            ushort card_no = 0;
            timer1.Enabled = false;
            CmbCardNo.Items.Clear();

            rc = CPCI_DIO.CS_PCI_DIO_open_card(ref exis_DIOtcard);

            if (exis_DIOtcard <= 0)
            {
                MessageBox.Show("No PCI-DIO card can be found!");
            }
            else
            {
                for (i = 0; i < exis_DIOtcard; i++)
                {
                   
                    rc = CPCI_DIO.CS_PCI_DIO_get_card_no(i, ref card_no);
                    gCardNoList[i] = card_no;
                    CmbCardNo.Items.Add(gCardNoList[i]);
                }
                CmbCardNo.Text = gCardNoList[0].ToString();
                gCardNo = (byte)gCardNoList[0];
                timer1.Enabled = true;
            }
        }

        private void btnexit_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            CPCI_DIO.CS_PCI_DIO_close();
            Application.Exit();
        }

     
        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort DIO_Version = 0;
            ushort DIO_DeviceID = 0;

            if (chkTimer.Checked)
            {
                rc = CPCI_DIO.CS_PCI_DIO_get_fpga_version(gCardNo, ref DIO_Version);
                    Ver_textBox.Text = DIO_Version.ToString();
                rc = CPCI_DIO.CS_PCI_DIO_get_hardware_id(gCardNo, ref DIO_DeviceID);
                    HardwareID_textBox.Text = DIO_DeviceID.ToString("X");
            }
        }

    }
}
