#if !defined(__PCI_DIO_ERROR_H__)
    #define __PCI_DIO_ERROR_H__

enum EErrorCode
{
    ERR_NO_ERROR            = 0,
    ERR_INIT_FAILED,
    ERR_NO_DEVICE_FOUND,
    ERR_DEVICE_NOT_INITIALIZED,
    ERR_PORT_IO_READ,
    ERR_PORT_IO_WRITE,
    ERR_MEMORY_READ,
    ERR_MEMORY_WRITE,
    ERR_SMBUS_INIT,
    ERR_SMBUS_READ,
    ERR_SMBUS_WRITE,
    ERR_SPI_INIT,
    ERR_SPI_READ,
    ERR_SPI_WRITE
};

#endif